<template>
  <q-page class="q-ma-xl">
    <q-table
      title="List of Users"
      align="left"
      :rows="rows"
      :columns="columns"
      row-key="name"
      :table-header-class="{ color: 'red' }"
    >
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td>
            <q-btn
              dense
              round
              flat
              color="blue-10"
              @click="updateUser(props.row)"
              icon="edit"
            />
            <q-btn
              dense
              round
              flat
              color="red-10"
              @click="
                () => {
                  confirm = true;
                  deleteRow = props.row;
                }
              "
              icon="delete"
            />
          </q-td>
          <q-td>
            {{ props.row.name }}
          </q-td>
          <q-td>
            {{ props.row.username }}
          </q-td>
          <q-td>
            {{ props.row.email }}
          </q-td>
          <q-td>
            {{
              props.row.address.street +
              ", " +
              props.row.address.suite +
              ", " +
              props.row.address.city +
              ", " +
              props.row.address.zipcode
            }}
          </q-td>
          <q-td>
            {{ props.row.number }}
          </q-td>
          <q-td>
            {{ props.row.website }}
          </q-td>
          <q-td>
            {{ props.row.company.companyName }}
          </q-td>
          <q-td>
            {{ props.row.company.catchPhrase }}
          </q-td>
          <q-td>
            {{ props.row.company.bs }}
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </q-page>

  <!-- Q-DIALOG OR MODAL -->
  <q-dialog v-model="confirm" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <div class="text-weight-medium">
          Are you sure you want to delete
          <span class="text-red">{{ deleteRow.name }}</span
          >?
        </div>
      </q-card-section>
      <q-card-actions align="right">
        <q-btn flat label="Cancel" color="green-10" v-close-popup />
        <q-btn
          @click="
            () => {
              deleteUser(deleteRow.id);
            }
          "
          flat
          label="Yes"
          color="pink-10"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { useRouter } from "vue-router";
import { ref } from "vue";
import axios from "axios";
import { user, selectedRow, isUpdating, form, id } from "../Composables/Pages";
import { userInfoUpdate } from "./AddUser";

export default {
  setup() {
    const router = useRouter();

    let columns = ref([
      {
        name: "actions",
        label: "Actions",
        align: "center",
        field: "",
      },
      {
        name: "name",
        label: "Name",
        align: "left",
        field: "name",
      },
      {
        name: "username",
        label: "Username",
        align: "left",
        field: "username",
      },
      {
        name: "email",
        label: "E-mail",
        align: "left",
        field: "email",
      },
      {
        name: "address",
        label: "Address",
        align: "left",
        field: "address",
      },
      {
        name: "phone",
        label: "Phone",
        align: "left",
        field: "phone",
      },
      {
        name: "website",
        label: "Website",
        align: "left",
        field: "website",
      },
      {
        name: "companyName",
        label: "Company Name",
        align: "left",
        field: "companyName",
      },
      {
        name: "catchPhrase",
        label: "Company's Catchphrase",
        align: "left",
        field: "catchPhrase",
      },
      {
        name: "bs",
        label: "Business Services",
        align: "left",
        field: "bs",
      },
    ]);
    let confirm = ref(false);

    let deleteRow = ref(null);

    let rows = ref([]);

    /* function to get the user from the server using GET request */
    const getUsers = () => {
      axios.get(" http://localhost:3000/users").then((response) => {
        rows.value = response.data.map((input) => ({
          id: input.id,
          name: input.name,
          username: input.username,
          email: input.email,
          address: {
            street: input.address.street,
            suite: input.address.suite,
            city: input.address.city,
            zipcode: input.address.zipcode,
          },
          number: input.number,
          website: input.website,
          company: {
            companyName: input.company.companyName,
            catchPhrase: input.company.catchPhrase,
            bs: input.company.bs,
          },
        }));
      });
    };

    //Removing a user from the list using delete-request method
    let deleteUser = (id) => {
      axios
        .delete(`http://localhost:3000/users/${id}`)
        .then((response) => {
          if (response.status === 200) {
            rows.value = rows.value.filter((user) => user.id !== id);
          }
          confirm.value = false;
        })
        .catch((error) => console.log(error));
    };

    let updateUser = (row) => {
      id.value = row.id;
      selectedRow.value = row;
      isUpdating.value = true;
      form.value = {
        name: row.name,
        number: row.number,
        username: row.username,
        email: row.email,
        street: row.address.street,
        suite: row.address.suite,
        city: row.address.city,
        zipcode: row.address.zipcode,
        company: row.company.companyName,
        website: row.website,
        catchphrase: row.company.catchPhrase,
        bs: row.company.bs,
      };
      router.push("/add-user");
    };

    getUsers();
    isUpdating.value = false;
    id.value = null;
    form.value = {
      name: null,
      username: null,
      email: null,
      street: null,
      suite: null,
      city: null,
      zipcode: null,
      number: null,
      website: null,
      company: null,
      catchphrase: null,
      bs: null,
    };

    return {
      updateUser,
      rows,
      columns,
      getUsers,
      user,
      deleteRow,
      deleteUser,
      confirm,
    };
  },
};
</script>
